// contact me at akaxeen.tyllo.de if you need help understanding the functions
var autosizerProgressListener = {
	QueryInterface: function(aIID) {
		if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
		  aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
		  aIID.equals(Components.interfaces.nsISupports))
		  return this;
		throw Components.results.NS_NOINTERFACE;
	},
	onProgressChange: function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
	onStatusChange: function(aWebProgress, aRequest, aStatus, aMessage) {},
	onSecurityChange: function(aWebProgress, aRequest, aState) {},
	onLinkIconAvailable: function(a) {},
	onStateChange: function (aWebProgress, aRequest, aStateFlags, aStatus) {},
	onLocationChange: function(aProgress, aRequest, aLocation) { if (aLocation) autosizer.genWidthCheck(false); }
}

function AutosizerPrefObserver() {
	autosizer.checkPrefs(false);
}

AutosizerPrefObserver.prototype = {
  observe: function(subject, topic, pref) {
		try { if (topic == 'nsPref:changed') autosizer.checkPrefs(false); } catch(e) {}
	}
};

var autosizer = {
	init: function() {  
		window.removeEventListener("load",function() { autosizer.init(); }, false);
    if(document.getElementById("gtbGoogleSearchBox").mInputField == null) {
      window.setTimeout("autosizer.init();",100);
      return;
    }
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getBranch('browser.search.');		
		
		if (this.prefs instanceof Components.interfaces.nsIPrefBranchInternal) {
			this.prefObserver = new AutosizerPrefObserver();
			this.prefs.addObserver('', this.prefObserver, false);
		}
		
	  this.txtOld=document.getElementById("searchbar");
		this.initVar(); 	
		
		var copyStyles=new Array('fontSize','fontSizeAdjust','fontStretch','fontStyle','fontVariant','fontWeight','letterSpacing','wordSpacing');
		var copyStyles2=new Array('font-size','font-size-adjust','font-stretch','font-style','font-variant','font-weight','letter-spacing','word-spacing');
		for(a in copyStyles) eval("this.label.style."+copyStyles[a]+"=document.defaultView.getComputedStyle(this.input, '').getPropertyValue('"+copyStyles2[a]+"'); ");		
		
		window.addEventListener("load",function() { autosizer.genWidthCheck(false); }, false);
		window.addEventListener("resize",function() { autosizer.genWidth(false); }, false);
		window.getBrowser().addProgressListener(autosizerProgressListener, Components.interfaces.nsIWebProgress.STATE_STOP);
		
		window.setTimeout("autosizer.startup();",0);
	}, 
	
	startup: function() {	
		this.getNeededWidth();		    
		this.genWidth(false); // Force once
	},
	
	initVar: function() { 
		this.txt=document.getElementById("gtbGoogleSearchBox");
		this.label=document.getElementById('autosizer-label'); 
		this.input=this.txt.mInputField;
	  
		if(this.txt.hasAttribute('sizetopopup')) {   
			this.txt.removeAttribute('sizetopopup');
			this.getNeededWidth();
		}
		
		this.diffWidth=(1+this.txt.boxObject.width)-this.input.offsetWidth;  		  
		this.txt.flex=0;   
},
	
	checkPrefs: function() {   
    this.offset=this.prefs.getIntPref('offset');
	  this.minwidth=this.prefs.getIntPref('minwidth');
		this.maxwidth=this.prefs.getIntPref('maxwidth');
		if(this.minwidth<37) this.minwidth=37;
		setTimeout("autosizer.genWidth(false);",0);
	},
	
	getNeededWidth: function() { 
		var toolbaritems=this.txt.parentNode.parentNode.childNodes,flextemp,i,x;
		this.neededWidth=0;
		for(i=0;x=toolbaritems[i];i++) {
			if(x.id=='search-container') continue;
			flextemp=x.getAttribute('flex');
			x.setAttribute('flex',0);
			this.neededWidth+=x.boxObject.width;
			x.setAttribute('flex',flextemp);
		}
	}, 	

	genWidth: function(evt) {
	  if(evt && evt.keyCode!=40 && evt.keyCode!=33 && evt.keyCode!=38 && evt.keyCode!=34 && this.txt.value.length>this.label.value.length+1) window.setTimeout("autosizer.focusEnd();",0); // on insertion fix - avoid if items were inserted by autocomplete	 			
    
    var availableWidth=window.outerWidth-this.neededWidth;     
    this.label.value=this.txt.value;     
	  var width=this.label.boxObject.width+this.diffWidth+this.offset+9; // +9 explaination: If you type something in the searchbox, it is too narrow and moves the query to the left to display the just typed in letter. Once this is done, autosizer resizes the searchbar to its needed width. However, the text does not realign automatically. Therefore Autosizer would have to do so (like it does for the on insertion fix) but this procedure is quite slow which makes the typing look laggy. To prevent this, I just add 9 pixels to give enough space for the next letter. When done so, the searchbar is wide enough and it doesn't move the text. If 9 pixels is too less for your theme/language increase the "offset".
		if(width>this.maxwidth && this.maxwidth>0) width=this.maxwidth; // set max width 
		if(width<this.minwidth && this.minwidth>0) width=this.minwidth; // set min width
		if(width>availableWidth && availableWidth>0) width=availableWidth; // available width
		if(width<this.diffWidth) width=this.diffWidth; // needed width	
    autosizer.txt.width=width; 
  
	},
	
	focusEnd: function() { 
	  const a=autosizer;
	  // This method only works when the searchabr isn't yet at its max-width
	  selStart=a.txt._textbox.selectionEnd; // Save cursor position

		temp=a.txt.value; // Save current value
		a.txt.value+=' '; // Just add a space/letter in the end to force the searchbar to realign the text after resizing (cursor is moved here)
		a.txt.value=temp; // remove the space again		
		
		// Focuses the end even if the searchbar is at its max-width
		if(selStart==a.txt._textbox.textLength) {
			var oEvent = document.createEvent('KeyEvents');  
			oEvent.initKeyEvent("keypress",true,true,null,false,false,false,false,oEvent.DOM_VK_END ,0);
		  a.input.dispatchEvent(oEvent);
		} else a.txt._textbox.setSelectionRange(selStart,selStart);
		
		// Unfortunately I don't know a way to focus the correct position if the searchbar is at its max-width if the text wasn't inserted at the end
	}, 
	
	genWidthCheck: function(evt) {
		this.initVar();     
		if(this.label.value!=this.txt.value) this.genWidth(evt);
	},  
	
	d: function(t) {
   Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService).logStringMessage('autosizer: '+t);
	}
}

window.addEventListener("load",function() { autosizer.init(); }, false);